
--MOD VG_PGA_SchweineMast      --																																																		
--MOD Version: 1.0 FS2015      --																																																				
--MOD Author:  Vanguard        --																																													
--MOD date: 5/1/2014           --																																																																																												
--Copyright (C) 2015 Vanguard  --																																														

-- #######################
-- # VG_PDA_SchweineMast
-- #######################

VG_PDA_SchweineMast = VG_PDA.VG_PDA_Screen:new();

VG_PDA_SchweineMast.moddir = g_currentModDirectory;
VG_PDA_SchweineMast.modName = g_currentModName;
if VG_PDA_SchweineMast.moddir:sub(-1) ~= '/' then
	VG_PDA_SchweineMast.moddir = VG_PDA_SchweineMast.moddir .. '/';
end;

function VG_PDA_SchweineMast:loadMap()
  self.isActive = false;
  self.showAnimal = 1;
  self.showUsage = false;
  
  self.husbandries = {};
  
  local found = false;
  for _, husbandry in pairs(g_currentMission.husbandries) do
    if husbandry.HookStatisticView ~= nil then
      found = true;
      table.insert(self.husbandries, husbandry);
    end;
  end;
  
  if not found then return; end;
  
  self.overlay = Overlay:new("VG_PDA_SchweineMast", Utils.getFilename('VG_PDA_storage.png', VG_PDA_SchweineMast.moddir), self.getOffsetX(), self.getOffsetY(), self.getWidth(), self.getHeight());
  local i18n;
  if g_currentMission.missionInfo.customEnvironment ~= nil then
    i18n = _G[g_currentMission.missionInfo.customEnvironment].g_i18n;
  else
    i18n = g_i18n;
  end;
  
  if i18n:hasText("MASeite") then
    self:registerScreen(i18n:getText("MASeite"));
  else
    self:registerScreen("Fattening Installations");
  end;
end;

function VG_PDA_SchweineMast:deleteMap()
  if self.overlay then
    self.overlay:delete();
    self.overlay = nil;
  end;
  
  self.husbandries = nil;
  self:deregisterScreen();
end;

function VG_PDA_SchweineMast:activate()
  self.isActive = true;
end;

function VG_PDA_SchweineMast:deactivate()
  self.isActive = false;
end;

function VG_PDA_SchweineMast:update()
  if self.isActive then
    if #self.husbandries > 1 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextAnimal"), InputBinding.VG_PDA_NEXT_PAGE);
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPrevAnimal"), InputBinding.VG_PDA_PREV_PAGE);
      
      if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
        self.showAnimal = self.showAnimal + 1;
        if self.showAnimal > #self.husbandries then
          self.showAnimal = 1;
        end;
      end;
      if InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
        self.showAnimal = self.showAnimal - 1;
        if self.showAnimal < 1 then
          self.showAnimal = #self.husbandries;
        end;
      end;
    end;
    g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowMoreStats"), InputBinding.VG_PDA_MORE_INFO);
    if InputBinding.hasEvent(InputBinding.VG_PDA_MORE_INFO) then
      self.showUsage = not self.showUsage;
    end;
  end;
end;

function VG_PDA_SchweineMast:draw()
  if not self.isActive then return end;
  
  self.overlay:render();
  
  local screenCols = self.getScreenCols();
  local topY, lineSpacing, colWidth, screenFont = 
    self.getTopY() + self.getMargin(), self.getLineSpacing(), self.getColWidth(), self.getScreenFont();
  local i18n;
  if g_currentMission.missionInfo.customEnvironment ~= nil then
    i18n = _G[g_currentMission.missionInfo.customEnvironment].g_i18n;
  else
    i18n = g_i18n;
  end;
  
  local FutterIntName = {[1] = i18n:getText("grain_fruits"),
                         [2] = i18n:getText("earth_fruits"),
                         [3] = i18n:getText("Silo_fruits"),
                         [4] = Fillable.fillTypeIndexToDesc[Fillable.FILLTYPE_FORAGE].nameI18N,
                         [5] = Fillable.fillTypeIndexToDesc[Fillable.FILLTYPE_WATER].nameI18N,
                         [6] = Fillable.fillTypeIndexToDesc[Fillable.FILLTYPE_WHEAT_WINDROW].nameI18N};


  
  local fluid_unit_short = " [" .. i18n:getText("fluid_unit_short") .. "]";
  
  local husbandry = self.husbandries[self.showAnimal];
  self.setTextColorBlack();
  setTextAlignment(RenderText.ALIGN_LEFT);
  renderText(screenCols[1], topY - lineSpacing * 1, screenFont, i18n:getText(husbandry.animal.."_amount"));
  setTextAlignment(RenderText.ALIGN_RIGHT);
  renderText(screenCols[3] + colWidth, topY - lineSpacing * 1, screenFont, g_i18n:formatNumber(husbandry.numPig));

  setTextAlignment(RenderText.ALIGN_LEFT);
  renderText(screenCols[1], topY - lineSpacing * 2, screenFont, i18n:getText("buy_amount"));
  setTextAlignment(RenderText.ALIGN_RIGHT);
  renderText(screenCols[3] + colWidth, topY - lineSpacing * 2, screenFont, g_i18n:formatNumber(husbandry.numSchweine));
  setTextAlignment(RenderText.ALIGN_LEFT);
  renderText(screenCols[1], topY - lineSpacing * 3, screenFont, i18n:getText("Productivity"));
  renderText(screenCols[4], topY - lineSpacing * 3, screenFont, "%");
  setTextAlignment(RenderText.ALIGN_RIGHT);
  renderText(screenCols[3] + colWidth, topY - lineSpacing * 3, screenFont, g_i18n:formatNumber(math.ceil(husbandry.Produktivi * 100)));
  setTextAlignment(RenderText.ALIGN_LEFT);
  renderText(screenCols[1], topY - lineSpacing * 4, screenFont, FutterIntName[4] .. fluid_unit_short);
  setTextAlignment(RenderText.ALIGN_RIGHT);
  renderText(screenCols[3] + colWidth, topY - lineSpacing * 4, screenFont, g_i18n:formatNumber(husbandry.FutterTypLvl[4]));

  local currentLine = 5;
  for i = 1, table.getn(husbandry.FutterTypLvl) do
    if i ~= 4 then
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, FutterIntName[i] .. fluid_unit_short);
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(screenCols[3] + colWidth, topY - lineSpacing * currentLine, screenFont, g_i18n:formatNumber(husbandry.FutterTypLvl[i]));
      currentLine = currentLine + 1;
    end;
  end;
  if husbandry.manureHeap then
    local nameI18N = Fillable.fillTypeIndexToDesc[Fillable.FILLTYPE_MANURE].nameI18N
    setTextAlignment(RenderText.ALIGN_LEFT);
    renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, nameI18N .. fluid_unit_short);
    setTextAlignment(RenderText.ALIGN_RIGHT);
    renderText(screenCols[3] + colWidth, topY - lineSpacing * currentLine, screenFont, g_i18n:formatNumber(husbandry.manureHeap.FillLvl));
    currentLine = currentLine + 1;
  end;
  if husbandry.liquidManureSiloTrigger then
    local nameI18N = Fillable.fillTypeIndexToDesc[Fillable.FILLTYPE_LIQUIDMANURE].nameI18N
    setTextAlignment(RenderText.ALIGN_LEFT);
    renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, nameI18N .. fluid_unit_short);
    setTextAlignment(RenderText.ALIGN_RIGHT);
    renderText(screenCols[3] + colWidth, topY - lineSpacing * currentLine, screenFont, g_i18n:formatNumber(husbandry.liquidManureSiloTrigger.fillLevel));
    currentLine = currentLine + 1;
  end;

end;
 
addModEventListener(VG_PDA_SchweineMast);